## sortmerna 4.3.6

=== CMakeLists.txt ===
﻿#===============================================================================
# FILE: CMakeLists.txt
# Created: Jun 06, 2017
#
# Top level CMake file for sortmerna
#===============================================================================

cmake_minimum_required(VERSION 3.13)
project(sortmerna CXX C)

set(CMAKE_CXX_STANDARD 17)

find_package(Git)

string(TIMESTAMP GIT_DATE_TIME "%Y/%m/%d %H:%M:%S" UTC)

#
# Prepare Version information
#
if(GIT_FOUND AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git")
  if(WIN32)
    execute_process(COMMAND $ENV{COMSPEC} /C ${GIT_EXECUTABLE} -C ${CMAKE_CURRENT_SOURCE_DIR} rev-parse HEAD OUTPUT_VARIABLE GIT_SHA)
  else()
    execute_process(COMMAND ${GIT_EXECUTABLE} -C ${CMAKE_CURRENT_SOURCE_DIR} rev-parse HEAD OUTPUT_VARIABLE GIT_SHA)
  endif()
else()
  set(GIT_SHA 0)
endif()

string(REGEX REPLACE "[^0-9a-f]+" "" GIT_SHA "${GIT_SHA}")

# Read sortmerna version from version.h file.
file(READ include/version.h version_header_file)
string(REGEX MATCH "#define SORTMERNA_MAJOR ([0-9]+)" _ ${version_header_file})
set(SORTMERNA_VERSION_MAJOR ${CMAKE_MATCH_1})
string(REGEX MATCH "#define SORTMERNA_MINOR ([0-9]+)" _ ${version_header_file})
set(SORTMERNA_VERSION_MINOR ${CMAKE_MATCH_1})
string(REGEX MATCH "#define SORTMERNA_PATCH ([0-9]+)" _ ${version_header_file})
set(SORTMERNA_VERSION_PATCH ${CMAKE_MATCH_1})
set(SORTMERNA_VERSION ${SORTMERNA_VERSION_MAJOR}.${SORTMERNA_VERSION_MINOR}.${SORTMERNA_VERSION_PATCH})


#include(ExternalProject)
message("CMAKE_CXX_COMPILER_ID = ${CMAKE_CXX_COMPILER_ID}") # 'GNU' on Ubuntu
message("CMAKE_CONFIGURATION_TYPES = ${CMAKE_CONFIGURATION_TYPES}")
message("CMAKE_HOST_SYSTEM_NAME = ${CMAKE_HOST_SYSTEM_NAME}")
message("CMAKE_HOST_SYSTEM_VERSION = ${CMAKE_HOST_SYSTEM_VERSION}")
message("CMAKE_HOST_SYSTEM = ${CMAKE_HOST_SYSTEM}")
message("PROJECT_BINARY_DIR = ${PROJECT_BINARY_DIR}")
message("CMAKE_BINARY_DIR = ${CMAKE_BINARY_DIR}")
message("CMAKE_CURRENT_BINARY_DIR = ${CMAKE_CURRENT_BINARY_DIR}")
message("RUNTIME_OUTPUT_DIRECTORY_RELEASE = ${RUNTIME_OUTPUT_DIRECTORY_RELEASE}")

# append sortmerna custom modules to cmake modules
message("CMAKE_CURRENT_LIST_DIR: ${CMAKE_CURRENT_LIST_DIR}")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake/modules/")

set(EXTERNAL_DEPS ${CMAKE_SOURCE_DIR}/3rdparty CACHE PATH "Installation directory for 3rd party dependencies")
set(ZLIB_URL https://github.com/madler/zlib.git CACHE STRING "ZLib GitHub URL")
set(ZLIB_ROOT ${EXTERNAL_DEPS}/zlib CACHE PATH "ZLIB installation directory")
set(ROCKSDB_URL https://github.com/facebook/rocksdb.git CACHE STRING "RocksDB GitHub URL")
set(ROCKSDB_SRC ${EXTERNAL_DEPS}/rocksdb CACHE PATH "RocksDB source root directory")
set(ROCKSDB_HOME ${EXTERNAL_DEPS}/rocksdb/dist CACHE PATH "RocksDB installation directory")
set(RAPIDJSON_URL https://github.com/Tencent/rapidjson CACHE STRING "RapidJSON GitHub URL")
set(RAPIDJSON_HOME ${EXTERNAL_DEPS}/rocksdb CACHE PATH "RapidJSON installation directory")
set(DIRENTWIN_URL https://github.com/tronkko/dirent CACHE STRING "Dirent-Windows interface GitHub URL")
set(DIRENTWIN_HOME ${EXTERNAL_DEPS}/dirent CACHE PATH "Dirent-Windows interface installation directory")
set(CONCURRENTQUEUE_URL https://github.com/cameron314/concurrentqueue CACHE STRING "Concurrent queue library GitHub URL")
set(CONCURRENTQUEUE_HOME ${EXTERNAL_DEPS}/concurrentqueue CACHE PATH "Concurrent queue library installation directory")
#set(gflags_DIR  ${EXTERNAL_DEPS}/gflags/dist/lib/cmake/gflags CACHE PATH "GFlags library configuration")

option(ROCKSDB_STATIC "Use static RocksDB library" ON)
option(ZLIB_STATIC "Use static ZLib library" ON)

option(PORTABLE "Build portable/statically linked executable" ON)

option(WITH_MD_LIBRARY "build with MD" ON)
if(WIN32 AND MSVC)
  if(NOT WITH_MD_LIBRARY)
	foreach(flag_var
		CMAKE_CXX_FLAGS 
		CMAKE_CXX_FLAGS_DEBUG 
		CMAKE_CXX_FLAGS_RELEASE
		CMAKE_CXX_FLAGS_MINSIZEREL 
		CMAKE_CXX_FLAGS_RELWITHDEBINFO
		CMAKE_C_FLAGS 
		CMAKE_C_FLAGS_DEBUG 
		CMAKE_C_FLAGS_RELEASE
		CMAKE_C_FLAGS_MINSIZEREL 
		CMAKE_C_FLAGS_RELWITHDEBINFO)
	   if(${flag_var} MATCHES "/MD")
		  string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
	   endif()
	endforeach(flag_var)
  endif()
endif()

option(WITH_RUNTIME_DEBUG "Build with MDd/MTd on Windows. Ignored on non-Windows" OFF)
if(WIN32 AND MSVC)
  if(NOT WITH_RUNTIME_DEBUG)
	foreach(flag_var
		CMAKE_CXX_FLAGS_DEBUG 
		CMAKE_C_FLAGS_DEBUG
		)
	   if(${flag_var} MATCHES "/MDd")
		  string(REGEX REPLACE "/MDd" "/MD" ${flag_var} "${${flag_var}}")
		elseif(${flag_var} MATCHES "/MTd")
		  string(REGEX REPLACE "/MTd" "/MT" ${flag_var} "${${flag_var}}")
	   endif()
	endforeach(flag_var)
  endif()
endif()

message("CMAKE_CXX_FLAGS_DEBUG: ${CMAKE_CXX_FLAGS_DEBUG}")
message("CMAKE_C_FLAGS_DEBUG: ${CMAKE_C_FLAGS_DEBUG}")

option(WITH_TESTS "Select whether to build tests" OFF)

if("${CMAKE_BUILD_TYPE}" STREQUAL "Release")
	if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" AND "${EXTRA_CXX_FLAGS_RELEASE}" STRGREATER "")
		set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${EXTRA_CXX_FLAGS_RELEASE}")
		set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} ${EXTRA_C_FLAGS_RELEASE}")
	endif()
endif()

message("CMAKE_CXX_FLAGS_RELEASE: ${CMAKE_CXX_FLAGS_RELEASE}")
message("EXTRA_CXX_FLAGS_RELEASE: ${EXTRA_CXX_FLAGS_RELEASE}")

## download zlib
#if(SRC_ZLIB AND NOT EXISTS ${EXTERNAL_DEPS}/zlib)
#	execute_process(COMMAND git clone --depth 1 https://github.com/madler/zlib
#		WORKING_DIRECTORY ${EXTERNAL_DEPS}
#	)
#endif()

## Download RocksDB
#if(SRC_ROCKSDB AND NOT EXISTS ${EXTERNAL_DEPS}/rocksdb)
#	execute_process(COMMAND git clone --depth 1 https://github.com/facebook/rocksdb
#		WORKING_DIRECTORY ${EXTERNAL_DEPS}
#	)
#endif()

#
# modify RocksDB thirdparty.inc - no need, it is modified before building RocksDB
#
#option(ROCKSDB_3RDPARTY_INC "Modify rocksdb/thirdparty.inc" OFF)
#if (ROCKSDB_3RDPARTY_INC)
#	include(smr_utils)
#	rocksdb_edit_3rdparty_inc()
#endif(ROCKSDB_3RDPARTY_INC)


## Download Rapidjson
#(SRC_RAPIDJSON AND NOT EXISTS ${EXTERNAL_DEPS}/rapidjson)
#	execute_process(COMMAND git clone --depth 1 https://github.com/Tencent/rapidjson
#		WORKING_DIRECTORY ${EXTERNAL_DEPS}
#	)
#endif()

# download dirent. Only dirent.h used from this project - no need to build
if(WIN32 AND NOT EXISTS ${DIRENTWIN_HOME})
	execute_process(COMMAND git clone --depth 1 ${DIRENTWIN_URL}
		WORKING_DIRECTORY ${EXTERNAL_DEPS}
)
endif()

## Download concurrentqueue
#if(NOT EXISTS ${EXTERNAL_DEPS}/concurrentqueue)
#	execute_process(COMMAND git clone --depth 1 https://github.com/cameron314/concurrentqueue
#		WORKING_DIRECTORY ${EXTERNAL_DEPS}
#	)
#endif()

# build build_version
set(BUILD_VERSION_CPP ${CMAKE_BINARY_DIR}/build_version.cpp)
configure_file(src/util/build_version.cpp.in ${BUILD_VERSION_CPP} @ONLY)
add_library(build_version OBJECT ${BUILD_VERSION_CPP})
target_include_directories(build_version PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include)

## build cmph
add_subdirectory(${EXTERNAL_DEPS}/cmph)

## build alp
add_subdirectory(${EXTERNAL_DEPS}/alp)

## build winapi
if(WIN32)
	add_subdirectory(${CMAKE_SOURCE_DIR}/src/winapi)
endif()

## build indexdb
#add_subdirectory(${CMAKE_SOURCE_DIR}/src/indexdb)

## build sortmerna
add_subdirectory(${CMAKE_SOURCE_DIR}/src/sortmerna)

if (WITH_TESTS)
  add_subdirectory (tests/sortmerna)
endif ()

# Installation and packaging
#set(CMAKE_INSTALL_PREFIX ${CMAKE_CURRENT_SOURCE_DIR}/dist CACHE PATH "Install path prefix, prepended onto install directories.")

#include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

set(package_config_destination ${CMAKE_INSTALL_PREFIX}/cmake/sortmerna)
message("package_config_destination: ${package_config_destination}")

configure_package_config_file(
	${CMAKE_CURRENT_LIST_DIR}/cmake/sortmernaConfig.cmake.in sortmernaConfig.cmake
	INSTALL_DESTINATION ${package_config_destination}
)

write_basic_package_version_file(
	sortmernaConfigVersion.cmake
	VERSION ${SORTMERNA_VERSION}
	COMPATIBILITY SameMajorVersion
)  

install(TARGETS sortmerna
	EXPORT sortmernaTargets
	RUNTIME 
	DESTINATION bin
	COMPONENT runtime
)

install(FILES
		${CMAKE_CURRENT_BINARY_DIR}/sortmernaConfig.cmake
		${CMAKE_CURRENT_BINARY_DIR}/sortmernaConfigVersion.cmake
	DESTINATION ${package_config_destination}
	COMPONENT config
)

# generate PACKAGE and PACKAGE_SOURCE targets, and CPack configuration files
# to build distribution archive/installer
set(CPACK_PACKAGE_VENDOR "Clarity Genomics")
set(CPACK_PACKAGE_DIRECTORY ${CMAKE_INSTALL_PREFIX})
set(CPACK_PACKAGE_VERSION_MAJOR ${SORTMERNA_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${SORTMERNA_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${SORTMERNA_VERSION_PATCH})
if(UNIX AND NOT APPLE) # CMAKE_HOST_SYSTEM_NAME = Linux
	set(CPACK_GENERATOR "DEB" "STGZ" "TGZ") # "TGZ" - use for Conda build to pick-up
	set(CPACK_DEBIAN_PACKAGE_DEBUG ON) # output Deb generator trace debug information
	#set(CPACK_DEB_COMPONENT_INSTALL ON) # Enable component packaging for CPackDEB
	if(NOT PORTABLE)
		set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
	endif()
	set(CPACK_DEBIAN_PACKAGE_MAINTAINER "biocodz")
endif()
include(CPack)

=== 3rdparty/alp/CMakeLists.txt ===
#===============================================================================
# FILE: CMakeLists.txt
# Created: Jun 10, 2017
#
# CMake file for sortmerna/3rdparty/alp
#===============================================================================

cmake_minimum_required(VERSION 3.13)
project(alp CXX)

set(CMAKE_CXX_STANDARD 11)

set(ALP_HDRS
	njn_approx.hpp
	njn_doubletype.hpp
	njn_dynprogprob.hpp
	njn_dynprogproblim.hpp
	njn_dynprogprobproto.hpp
	njn_function.hpp
	njn_integer.hpp
	njn_ioutil.hpp
	njn_localmaxstat.hpp
	njn_localmaxstatmatrix.hpp
	njn_localmaxstatutil.hpp
	njn_matrix.hpp
	njn_memutil.hpp
	njn_random.hpp
	njn_root.hpp
	njn_uniform.hpp
	njn_vector.hpp
	sls_alignment_evaluer.hpp
	sls_alp.hpp
	sls_alp_data.hpp
	sls_alp_regression.hpp
	sls_alp_sim.hpp
	sls_basic.hpp
	sls_normal_distr_array.hpp
	sls_pvalues.hpp
)

set (ALP_SRCS
	njn_dynprogprob.cpp
	njn_dynprogproblim.cpp
	njn_dynprogprobproto.cpp
	njn_ioutil.cpp
	njn_localmaxstat.cpp
	njn_localmaxstatmatrix.cpp
	njn_localmaxstatutil.cpp
	njn_random.cpp
	sls_alignment_evaluer.cpp
	sls_alp.cpp
	sls_alp_data.cpp
	sls_alp_regression.cpp
	sls_alp_sim.cpp
	sls_basic.cpp
	sls_pvalues.cpp
)


add_Library(alp OBJECT ${ALP_HDRS} ${ALP_SRCS})
target_include_directories(alp PUBLIC ${CMAKE_SOURCE_DIR}/3rdparty/alp)

#add_Library(alp INTERFACE)
#target_sources(alp INTERFACE ${ALP_HDRS})

=== 3rdparty/cmph/CMakeLists.txt ===
#===============================================================================
# FILE: CMakeLists.txt
# Created: Jun 08, 2017
#
# CMake file for sortmerna/cmph
#===============================================================================

cmake_minimum_required(VERSION 3.13)
project(cmph CXX)

#AUX_SOURCE_DIRECTORY(${CMAKE_SOURCE_DIR}/cmph CMPH_SRCS)
#include_directories(${CMAKE_SOURCE_DIR}/cmph)              # not recommended practice. 
#file(GLOB CMPH_HDRS ${CMAKE_SOURCE_DIR}/cmph "*.h" )       # not recommended practice. List files explicitly

# find C:/a03_libs/sortmerna/cmph -name '*.h' -printf "%f\n"
# OpenCV only uses fraction of these files
set(CMPH_HDRS
    bdz.h
	bdz_ph.h
	bdz_structs.h
	bdz_structs_ph.h
	bitbool.h
	bmz.h
	bmz8.h
	bmz8_structs.h
	bmz_structs.h
	brz.h
	brz_structs.h
	buffer_entry.h
	buffer_manager.h
	chd.h
	chd_ph.h
	chd_structs.h
	chd_structs_ph.h
	chm.h
	chm_structs.h
	cmph.h
	cmph_structs.h
	cmph_time.h
	cmph_types.h
	compressed_rank.h
	compressed_seq.h
	debug.h
	fch.h
	fch_buckets.h
	fch_structs.h
	graph.h
	hash.h
	hash_state.h
	jenkins_hash.h
	miller_rabin.h
	select.h
	select_lookup_tables.h
	vqueue.h
	vstack.h
)

# find C:/a03_libs/sortmerna/cmph -name '*.c' -printf "%f\n"
# OpenCV only uses fraction of these files
set(CMPH_SRCS
	bdz.c
	bdz_ph.c
	bmz.c
	bmz8.c
	brz.c
	buffer_entry.c
	buffer_manager.c
	chd.c
	chd_ph.c
	chm.c
	cmph.c
	cmph_structs.c
	compressed_rank.c
	compressed_seq.c
	fch.c
	fch_buckets.c
	graph.c
	hash.c
	jenkins_hash.c
	miller_rabin.c
	select.c
	vqueue.c
	vstack.c
)

#message("CMPH_SRCS= ${CMPH_SRCS}\nCMPH_PRIVATE_HDRS= ${CMPH_PRIVATE_HDRS}")

add_library(cmph OBJECT ${CMPH_SRCS} ${CMPH_HDRS})
target_include_directories(cmph PUBLIC ${CMAKE_SOURCE_DIR}/3rdparty/cmph)

=== src/sortmerna/CMakeLists.txt ===
#===============================================================================
# FILE: CMakeLists.txt
# Created: Jun 08, 2017
#
# CMake file for sortmerna/src/sortmerna
#===============================================================================

cmake_minimum_required(VERSION 3.13)
project(sortmerna CXX)

set(CMAKE_CXX_STANDARD 17)

find_package(Threads REQUIRED)

find_package(RocksDB CONFIG REQUIRED
  PATHS ${ROCKSDB_HOME}
  NO_DEFAULT_PATH
)

if(RocksDB_FOUND)
	message("RocksDB package OK")
else()
	message("RocksDB package NOK")
endif()

# 
get_target_property(lib RocksDB::rocksdb-shared LOCATION)
message("RocksDB::rocksdb-shared LOCATION: ${lib}")
get_target_property(lib RocksDB::rocksdb-shared LOCATION_DEBUG)
message("RocksDB::rocksdb-shared LOCATION_DEBUG: ${lib}")
get_target_property(lib RocksDB::rocksdb-shared IMPORTED_LOCATION_DEBUG)
message("RocksDB::rocksdb-shared LOCATION_DEBUG: ${lib}")
get_target_property(cfg RocksDB::rocksdb-shared IMPORTED_CONFIGURATIONS)
message("RocksDB::rocksdb-shared IMPORTED_CONFIGURATIONS: ${cfg}")
get_target_property(lib RocksDB::rocksdb-shared IMPORTED_IMPLIB)
message("RocksDB::rocksdb-shared IMPORTED_IMPLIB: ${lib}")

get_target_property(lib RocksDB::rocksdb LIBRARY_OUTPUT_NAME)
message("RocksDB::rocksdb LIBRARY_OUTPUT_NAME: ${lib}")

 if(ROCKSDB_STATIC)
	message("Using Static RocksDB lib")
    set(ROCKSDB_LIB RocksDB::rocksdb)
 else()
	message("Using Shared RocksDB lib")
    set(ROCKSDB_LIB RocksDB::rocksdb-shared)
	#if(WIN32 AND MSVC)
	#	set_target_properties(RocksDB::rocksdb-shared PROPERTIES
	#		IMPORTED_IMPLIB "${ROCKSDB_HOME}/lib/rocksdb-shared.lib"
	#	)
	#endif()
endif()

get_property(trans_deps TARGET ${ROCKSDB_LIB} PROPERTY INTERFACE_LINK_LIBRARIES)
message("${ROCKSDB_LIB} transitive link dependencies: ${trans_deps}")

# fix RocksDBTargets.cmake, which makes both static and shared libraries always dependent on libz.so
if(NOT WIN32)
	if(ZLIB_LIBRARY_RELEASE)
		# modify the dependent libraries of the RocksDB::rocksdb target
		set_target_properties(RocksDB::rocksdb PROPERTIES
			INTERFACE_LINK_LIBRARIES "${ZLIB_LIBRARY_RELEASE};Threads::Threads"
		)
	endif()
endif()

get_property(trans_deps TARGET RocksDB::rocksdb PROPERTY INTERFACE_LINK_LIBRARIES)
message("rocksdb transitive link dependencies AFTER modification: ${trans_deps}")

include(FindZLIB)
# prevent CONFIG search mode
find_package(ZLIB MODULE REQUIRED)

include(FindRapidJson)
 # prevent CONFIG search mode
find_package(RapidJson MODULE REQUIRED)

# set additional compile flags
if(MSVC)
#  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zi /nologo /EHsc /GS /Gd /GR /GF /fp:precise /Zc:wchar_t /Zc:forScope /errorReport:queue")
#  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /FC /d2Zi+ /W4 /wd4127 /wd4800 /wd4996 /wd4351 /wd4100 /wd4204 /wd4324")
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -W -Wextra -Wall -Xlinker -v") # -Xlinker -v / --verbose (linked libraries info)   '-Wl,-Map,mapfile.txt'  '-Wl,-v'
  #set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -v -da -Q") # for segfault
  #                                                    |  |   |_show which function is causing the crash.
  #                                                    |  |_dumps the RTL to a file after each stage
  #                                                    |_show how the program was invoked
  #set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -v -da -Q -O0") # for segfault
#  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsign-compare -Wshadow -Wno-unused-parameter -Wno-unused-variable -Woverloaded-virtual -Wnon-virtual-dtor -Wno-missing-field-initializers -Wno-strict-aliasing")
endif()

#set(MY_OPTS -g -Wall) # using quotes "-g -Wall" throws error
#target_compile_options(smr_objs PUBLIC ${MY_OPTS})
#target_compile_options(smr_objs PUBLIC "$<$<CONFIG:DEBUG>:${MY_OPTS}>")
#target_compile_options(smr_objs PUBLIC "$<$<CONFIG:RELEASE>:${MY_OPTS}>")
#set_target_properties(smr_objs PROPERTIES COMPILE_OPTIONS ${MY_OPTS})

set(SMR_SRCS
	alignment.cpp
	bitvector.cpp
	#callbacks.cpp
	cmd.cpp
	izlib.cpp
	index.cpp
	indexdb.cpp
	kseq_load.cpp
	kvdb.cpp
	options.cpp
	output.cpp
	summary.cpp
	paralleltraversal.cpp
	processor.cpp
	read.cpp
	#read_control.cpp
	readfeed.cpp
	readstats.cpp
	references.cpp
	refstats.cpp
	ssw.c
	traverse_bursttrie.cpp
	util.cpp
	otumap.cpp
	report.cpp
	report_fx_base.cpp
	report_fastx.cpp
	report_fx_other.cpp
	report_blast.cpp
	report_denovo.cpp
	report_biom.cpp
	report_sam.cpp
	#writer.cpp
)

# SMR Objects - build a separate library to use with Tests
add_library(smr_objs OBJECT ${SMR_SRCS})
target_link_libraries(smr_objs
	PUBLIC
		alp
		${ROCKSDB_LIB}
		RapidJSON::RapidJSON
		ZLIB::ZLIB
)
if(WIN32)
	target_include_directories(smr_objs 
		PUBLIC
			${CMAKE_SOURCE_DIR}/include
			$<TARGET_PROPERTY:winapi,INCLUDE_DIRECTORIES>
			$<TARGET_PROPERTY:cmph,INCLUDE_DIRECTORIES>
			${DIRENTWIN_HOME}/include
			${CONCURRENTQUEUE_HOME}
	)
else()
	target_include_directories(smr_objs 
		PUBLIC
			${CMAKE_SOURCE_DIR}/include
			$<TARGET_PROPERTY:cmph,INCLUDE_DIRECTORIES>
			${CONCURRENTQUEUE_HOME}
	)
endif()

get_property(trans_deps TARGET smr_objs PROPERTY INTERFACE_LINK_LIBRARIES)
message("SMR Objects transitive link dependencies: ${trans_deps}")

get_target_property(COMPILE_OPT smr_objs COMPILE_OPTIONS)
get_target_property(COMPILE_FLG smr_objs COMPILE_FLAGS)
message("SMR Objects COMPILE_OPT: ${COMPILE_OPT}  COMPILE_FLG: ${COMPILE_FLG}")

# SMR
add_executable(sortmerna main.cpp)
if(WIN32)
	target_include_directories(sortmerna 
		PRIVATE
			${CMAKE_SOURCE_DIR}/include
			${DIRENTWIN_HOME}/include
			${CONCURRENTQUEUE_HOME}
	)
	target_link_libraries(sortmerna
		build_version
		smr_objs
		winapi
		alp
		$<TARGET_OBJECTS:cmph>
		ZLIB::ZLIB
		${ROCKSDB_LIB}
		RapidJSON::RapidJSON
		Rpcrt4.lib
		Cabinet.lib # rocksdb:XPRESS::CreateCompressor,Compress,CloseCompressor,CreateDecompressor,Decompress,CloseDecompressor
	)
else()
	target_include_directories(sortmerna 
		PRIVATE
			${CONCURRENTQUEUE_HOME}
			${CMAKE_SOURCE_DIR}/include
	)
	#get_property(rocksdb_trans_deps TARGET RocksDB::rocksdb PROPERTY INTERFACE_LINK_LIBRARIES)
	#message("rocksdb_trans_deps: ${rocksdb_trans_deps}")
	target_link_libraries(sortmerna
		build_version
		smr_objs
		alp # this is a transitive dependency of smr_objs but the linking fails without it. Why?
		$<TARGET_OBJECTS:cmph>
		${ROCKSDB_LIB}
		${CMAKE_DL_LIBS}
		# the following are all transitive dependencies of smr_objs i.e. no need to link: 
		# RapidJSON::RapidJSON ZLIB::ZLIB Threads::Threads (rockdb deps)
	)
	
	if(PORTABLE)
		target_link_options(sortmerna PRIVATE -static)
	endif(PORTABLE)
endif()

=== src/winapi/CMakeLists.txt ===
#===============================================================================
# FILE: CMakeLists.txt
# Created: Jun 10, 2017
#
# CMake file for sortmerna/src/winapi
#===============================================================================

cmake_minimum_required(VERSION 3.13)
project(winapi CXX)

set(WINAPI_HDRS
	include/unistd.h
	include/sys/time.h
)

#add_subdirectory(${CMAKE_SOURCE_DIR}/winapi)

set(WINAPI_SRCS
	unistd.cpp
	wintime.cpp
)

#message("${WINAPI_SRCS}")

add_library(winapi OBJECT ${WINAPI_SRCS} ${WINAPI_HDRS})

source_group(sys FILES ${CMAKE_SOURCE_DIR}/src/winapi/include/sys/time.h) # Not working: "Header Files\\sys" "include\\sys" "sys"

target_include_directories(winapi PUBLIC ${CMAKE_SOURCE_DIR}/src/winapi/include)

=== tests/sortmerna/CMakeLists.txt ===
#===============================================================================
# FILE: CMakeLists.txt
# Created: Jun 06, 2018 Wed
#===============================================================================

cmake_minimum_required(VERSION 3.13)
project(tests CXX)

set(CMAKE_CXX_STANDARD 17)

message("tests PROJECT_NAME = ${PROJECT_NAME}")
message("tests PROJECT_BINARY_DIR = ${PROJECT_BINARY_DIR}")
message("tests CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")
message("tests CMAKE_CFG_INTDIR = ${CMAKE_CFG_INTDIR}")

set(TEST_SRCS
	kvdb.cpp
	main.cpp
)

add_executable(tests ${TEST_SRCS})
#target_include_directories(tests
#PRIVATE
#		${CMAKE_SOURCE_DIR}/include
#		#${CMAKE_SOURCE_DIR}/src/winapi/include
#)
if(WIN32)
	target_link_libraries(tests
		build_version
		alp
		smr_objs
		winapi
		$<TARGET_OBJECTS:cmph>
	)
else()
	target_link_libraries(tests
		build_version
		alp
		smr_objs
		$<TARGET_OBJECTS:cmph>
	)
endif()

#add_executable("test_${test}" ${test}.cpp $<TARGET_OBJECTS:smr_objs>)

## sortmerna 2.0

=== debian/changelog ===
sortmerna (2.0-1) unstable; urgency=medium

  * Initial upload to Debian (Closes: #794607)

 -- Andreas Tille <tille@debian.org>  Tue, 04 Aug 2015 21:27:07 +0200

sortmerna (2.0-0biolinux1) trusty; urgency=medium

  * Initial release.
  * Lose memcheck.h from the build to simplify licensing.

 -- Tim Booth <tbooth@ceh.ac.uk>  Fri, 13 Feb 2015 18:00:35 +0000

=== debian/control ===
Source: sortmerna
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Tim Booth <tbooth@ceh.ac.uk>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9), dh-autoreconf
Standards-Version: 3.9.6
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/sortmerna/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/sortmerna/trunk/
Homepage: http://bioinfo.lifl.fr/RNA/sortmerna/

Package: sortmerna
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: python
Description: tool for filtering, mapping and OTU-picking NGS reads
 SortMeRNA is a biological sequence analysis tool for filtering, mapping and
 OTU-picking NGS reads. The core algorithm is based on approximate seeds and
 allows for fast and sensitive analyses of nucleotide sequences. The main
 application of SortMeRNA is filtering rRNA from metatranscriptomic data.
 Additional applications include OTU-picking and taxonomy assignation available
 through QIIME v1.9+ (http://qiime.org - v1.9.0-rc1).
 SortMeRNA takes as input a file of reads (fasta or fastq format) and one or
 multiple rRNA database file(s), and sorts apart rRNA and rejected reads into
 two files specified by the user. Optionally, it can provide high quality local
 alignments of rRNA reads against the rRNA database. SortMeRNA works with
 Illumina, 454, Ion Torrent and PacBio data, and can produce SAM and
 BLAST-like alignments.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --includedir=/usr/include/sortmerna

override_dh_clean:
	dh_clean
	rm -f index/.tobuild
	rm -f include/memcheck.h
	rm -rf tmp

override_dh_auto_build:
	touch index/.tobuild
	dh_auto_build
	mkdir -p tmp
	cat debian/README_scripts.txt rRNA_databases/README.txt > tmp/README.txt

override_dh_auto_install:
	#Skip this - do it manually
	true

override_dh_fixperms:
	dh_fixperms
	find debian/sortmerna -name '*.sh' -exec chmod +x '{}' ';'
	find debian/sortmerna -name '*.py' -exec chmod -x '{}' ';'

override_dh_compress:
	dh_compress --exclude=.pdf

## sortmerna 2.1

=== debian/changelog ===
sortmerna (2.1-5) unstable; urgency=medium

  * Team upload.

  [ Pranav Ballaney ]
  * Add autopkgtest template and README.test
  * Install examples
  * Add autopkgtests

  [ Andreas Tille ]
  * Standards-Version: 4.5.0 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)

 -- Pranav Ballaney <ballaneypranav@gmail.com>  Sat, 21 Mar 2020 00:57:31 +0530

sortmerna (2.1-4) unstable; urgency=medium

  * Use 2to3 to port from Python2 to Python3
    Closes: #945707
  * debhelper-compat 12
  * Standards-Version: 4.4.1
  * Secure URI in copyright format
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Database, Bug-Submit (from
    ./configure), Repository, Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Wed, 25 Dec 2019 21:25:41 +0100

sortmerna (2.1-3) unstable; urgency=medium

  [ Steffen Moeller ]
  * debian/upstream/metadata
    - added references to registries
    - yamllint cleanliness

  [ Andreas Tille ]
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1

 -- Andreas Tille <tille@debian.org>  Tue, 09 Oct 2018 17:26:27 +0200

sortmerna (2.1-2) unstable; urgency=medium

  * Moved packaging from SVN to Git
  * debhelper 10
  * Standards-Version: 4.1.0 (no changes needed)
  * Restrict set of architectures, Depends: sse2-support on i386
    Closes: #818505
  * hardening=+all

 -- Andreas Tille <tille@debian.org>  Mon, 25 Sep 2017 13:32:01 +0200

sortmerna (2.1-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Thu, 10 Mar 2016 23:39:18 +0100

=== debian/control ===
--- 
+++ 
@@ -4,17 +4,22 @@
            Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9), dh-autoreconf
-Standards-Version: 3.9.6
-Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/sortmerna/trunk/
-Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/sortmerna/trunk/
-Homepage: http://bioinfo.lifl.fr/RNA/sortmerna/
+Build-Depends: debhelper-compat (= 12),
+#               python3 <!nocheck>,
+#               python3-skbio <!nocheck>,
+Standards-Version: 4.5.0
+Vcs-Browser: https://salsa.debian.org/med-team/sortmerna
+Vcs-Git: https://salsa.debian.org/med-team/sortmerna.git
+Homepage: https://bioinfo.lifl.fr/RNA/sortmerna/
+Rules-Requires-Root: no
 
 Package: sortmerna
-Architecture: any
+Architecture: any-amd64 any-i386 x32
 Depends: ${shlibs:Depends},
-         ${misc:Depends}
-Recommends: python
+         ${misc:Depends},
+         sse2-support [any-i386]
+Recommends: python3,
+#            python3-skbio
 Description: tool for filtering, mapping and OTU-picking NGS reads
  SortMeRNA is a biological sequence analysis tool for filtering, mapping and
  OTU-picking NGS reads. The core algorithm is based on approximate seeds and
@@ -28,4 +33,3 @@
  alignments of rRNA reads against the rRNA database. SortMeRNA works with
  Illumina, 454, Ion Torrent and PacBio data, and can produce SAM and
  BLAST-like alignments.
-

=== debian/watch ===
version=3
# The file naming is inconsistent, so you'll need to look here manually:
# http://bioinfo.lifl.fr/RNA/sortmerna/
https://github.com/biocore/sortmerna/releases .*/archive/(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## sortmerna 4.3.6

=== debian/changelog ===
sortmerna (4.3.6-2) unstable; urgency=medium

  * d/rules: remove dh_clean override; not needed anymore.
  * d/rules: move to execute_after_ statements.
  * d/rules: verbose remove of cmake/ directories.
  * d/rules: verbose permissions changes.
  * d/control: add myself to uploaders.
  * d/control: declare compliance to standards version 4.6.2.
  * d/rules: build for i386 with -msse2.
    The package depends on sse2-support for that architecture, so this is
    not a baseline violation in this particular case. (Closes: #1028122)

 -- Étienne Mollier <emollier@debian.org>  Sat, 07 Jan 2023 16:52:43 +0100

sortmerna (4.3.6-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Tue, 29 Nov 2022 18:06:13 +0100

sortmerna (4.3.4-1) experimental; urgency=medium

  [ Steffen Möller ]
  * Update watch - we missed a couple of versions

  [ Andreas Tille ]
  * New upstream version
  * debhelper-compat 13 (routine-update)
  * Standards-Version: 4.6.0 (routine-update)
  * Build-Depends: cmake
  * Remove Tim Booth from Uploaders (thanks for all your work Tim)
  * Versioned Build-Depends: librocksdb-dev (>= 6.25.3)
  * Build-Depends: libgflags-dev, libsnappy-dev, libzstd-dev
    (needed by librocksdb-dev (>= 6.25.3) - see #1004665)
  * Build-Depends: rapidjson-dev, libconcurrentqueue-dev
  * Review copyright
  * Deactivate autopkgtest which is based on binary indexdb_rna
    which is not available any more
  * Use tags in watch file
  * Warn users about missing binary indexdb_rna in NEWS.Debian

 -- Andreas Tille <tille@debian.org>  Tue, 15 Feb 2022 19:51:10 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,20 @@
 Source: sortmerna
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Tim Booth <tbooth@ceh.ac.uk>,
-           Andreas Tille <tille@debian.org>
+Uploaders: Andreas Tille <tille@debian.org>,
+           Étienne Mollier <emollier@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
+               cmake,
+               librocksdb-dev (>= 6.25.3),
+               libgflags-dev,
+               libsnappy-dev,
+               libzstd-dev,
+               rapidjson-dev,
+               libconcurrentqueue-dev
 #               python3 <!nocheck>,
 #               python3-skbio <!nocheck>,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/sortmerna
 Vcs-Git: https://salsa.debian.org/med-team/sortmerna.git
 Homepage: https://bioinfo.lifl.fr/RNA/sortmerna/

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export CMAKE_PREFIX_PATH=/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/

# In this particular instance, building with sse2 support is not an
# architecture baseline violation for the i386 release architecture, because
# the package is supposed to depend on sse2-support.
ifeq ($(DEB_HOST_ARCH),i386)
export DEB_CFLAGS_MAINT_APPEND+=-msse2
export DEB_CXXFLAGS_MAINT_APPEND+=-msse2
endif

%:
	dh $@

execute_after_dh_install:
	find debian -name cmake -type d | xargs rm -rvf

execute_after_dh_fixperms:
	find debian/sortmerna -name '*.sh' -exec chmod -v +x '{}' ';'
	find debian/sortmerna -name '*.py' -exec chmod -v -x '{}' ';'

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%sortmerna-$1.tar.gz%" \
   https://github.com/biocore/sortmerna/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
